(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define("scalar", [], factory);
	else if(typeof exports === 'object')
		exports["scalar"] = factory();
	else
		root["scalar"] = factory();
})(self, () => {
return /******/ (() => { // webpackBootstrap
/******/ 	"use strict";
/******/ 	// The require scope
/******/ 	var __webpack_require__ = {};
/******/ 	
/************************************************************************/
/******/ 	/* webpack/runtime/define property getters */
/******/ 	(() => {
/******/ 		// define getter functions for harmony exports
/******/ 		__webpack_require__.d = (exports, definition) => {
/******/ 			for(var key in definition) {
/******/ 				if(__webpack_require__.o(definition, key) && !__webpack_require__.o(exports, key)) {
/******/ 					Object.defineProperty(exports, key, { enumerable: true, get: definition[key] });
/******/ 				}
/******/ 			}
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/hasOwnProperty shorthand */
/******/ 	(() => {
/******/ 		__webpack_require__.o = (obj, prop) => (Object.prototype.hasOwnProperty.call(obj, prop))
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/make namespace object */
/******/ 	(() => {
/******/ 		// define __esModule on exports
/******/ 		__webpack_require__.r = (exports) => {
/******/ 			if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 				Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 			}
/******/ 			Object.defineProperty(exports, '__esModule', { value: true });
/******/ 		};
/******/ 	})();
/******/ 	
/************************************************************************/
var __webpack_exports__ = {};
// ESM COMPAT FLAG
__webpack_require__.r(__webpack_exports__);

// EXPORTS
__webpack_require__.d(__webpack_exports__, {
  Component: () => (/* reexport */ Component),
  Module: () => (/* reexport */ Module),
  customElement: () => (/* reexport */ customElement)
});

;// CONCATENATED MODULE: ./src/util/Element.js
function getObject(obj, props, value, index) {
  var key = props[index];
  obj[key] = ++index < props.length ? getObject(obj[key] || (isNaN(props[index]) ? {} : []), props, value, index) : value;
  return obj;
}
function clone(object) {
  if (Array.isArray(object)) {
    return object.map(function (obj) {
      return clone(obj);
    });
  }
  return Object.assign({}, object);
}
function generateUUID(obj) {
  var uuid = 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function (c) {
    var r = Math.random() * 16 | 0;
    var v = c == 'x' ? r : r & 0x3 | 0x8;
    return v.toString(16);
  });
  Object.defineProperty(obj, 'uuid', {
    value: uuid,
    configurable: false,
    writable: false
  });
  return uuid;
}
function setPropertyValue(property, prop, value) {
  property.v = prop.length ? getObject(property.v || {}, prop, value, 0) : value;
}
;// CONCATENATED MODULE: ./src/util/Event.js

var hasObjectConfig = false;
document.createElement('b').addEventListener('load', null, Object.defineProperty({}, 'passive', {
  get: function get() {
    hasObjectConfig = true;
  }
}));
function bindFunction(name, $element, fn) {
  var lastChar = name.length - 1;
  var capture = false;
  var passive = true;
  if (name.indexOf('_') === 0) {
    var method = fn;
    fn = function fn(e) {
      return method.call($element, e) !== true && e.preventDefault();
    };
    fn.uuid = method.uuid;
    passive = false;
    name = name.substring(1);
  }
  if (name.lastIndexOf('_') === lastChar) {
    capture = true;
    name = name.substring(0, lastChar);
  }
  var opt = hasObjectConfig ? {
    passive: passive,
    capture: capture
  } : capture;
  $element.addEventListener(name, fn, opt);
  $element.eventListenerList.push({
    name: name,
    fn: fn,
    opt: opt
  });
}
function addListeners($element, events) {
  var _loop = function _loop() {
    var fn = events[selector];
    if (fn instanceof Function) {
      var binding = !$element.eventListenerList;
      if (binding) {
        $element.eventListenerList = [];
      }
      if (!fn.uuid) {
        binding = generateUUID(fn);
      }
      if (binding || !$element.eventListenerList.find(function (listener) {
        return listener.fn.uuid === fn.uuid;
      })) {
        bindFunction(selector, $element, fn);
      }
    } else {
      var $nodeList = $element.querySelectorAll(selector);
      for (var i = 0, $node; $node = $nodeList[i]; i++) {
        addListeners($node, fn);
      }
    }
  };
  for (var selector in events) {
    _loop();
  }
}
;// CONCATENATED MODULE: ./src/util/Wrapper.js

var correlation = {};
function set(object, properties) {
  var uuid = object.uuid;
  if (!uuid) {
    uuid = generateUUID(object);
  }
  correlation[uuid] = properties;
  return uuid;
}
function get(object) {
  var uuid = object.uuid;
  if (!uuid) {
    uuid = set(object, {});
  }
  return correlation[uuid];
}
;// CONCATENATED MODULE: ./src/observable/Attribute.js


/**
 *
 * @var {attribute.n} name Nombre del atributo
 * @var {attribute.a} attribute Elemento del DOM que representa el atributo
 * @var {attribute.$} $element Elemento HTML al que pertenece el atributo
 * @var {attribute.pn} propertyName Nombre de la propiedad a la que pertenece el atributo
 * @var {attribute.exp} expression? Expresión que se debe evaluar para que tome el valor el atributo
 */
function setAttribute($attribute, name, property) {
  var _$attribute$tagName;
  var isObject = property instanceof Object;
  if ((_$attribute$tagName = $attribute.tagName) !== null && _$attribute$tagName !== void 0 && _$attribute$tagName.includes("-")) {
    if (isObject) {
      property = JSON.stringify(property);
    }
    $attribute.setAttribute(name, property || '');
  } else if (isObject && $attribute[name] instanceof Object) {
    for (var key in property) {
      setAttribute($attribute[name], key, property[key]);
    }
  } else if ($attribute[name] !== property) {
    $attribute[name] = property;
  }
}
function getPropertyValue(value, properties) {
  for (var i = 0, prop; prop = properties[i]; i++) {
    if (!value[prop]) return false;
    value = value[prop];
  }
  return value;
}
function create(property, name, $element, prop, exp) {
  var keys = name.split('.');
  var value = property.v;
  var $attribute = $element;
  name = keys.pop();
  keys.forEach(function (k) {
    $attribute = $attribute[k];
  });
  var attribute = {
    n: name,
    a: $attribute,
    $: $element,
    pn: prop,
    exp: exp
  };
  exp || getPropertyValue(value, prop) ? execute(property, attribute, value) : setPropertyValue(property, prop, $attribute[name]);
  return attribute;
}
function execute(property, attribute, value) {
  var $element = attribute.$;
  var name = attribute.n;
  var eventListenerList = $element.eventListenerList;
  var privyComponent = property.pc;
  value = attribute.exp ? Function('p', 'return ' + attribute.exp)(property.c) : getPropertyValue(value, attribute.pn);
  setAttribute(attribute.a, name, value);
  if (eventListenerList && (name.indexOf('class') === 0 || name === 'id')) {
    while (eventListenerList.length) {
      var listener = eventListenerList.shift();
      $element.removeEventListener(listener.name, listener.fn, listener.opt);
    }
    addListeners(privyComponent.$, privyComponent.e_);
  }
}
;// CONCATENATED MODULE: ./src/view/DOM.js
function updateProps(property, $target, newProps, oldProps) {
  for (var i = oldProps.length - 1; i >= 0; i--) {
    var _oldProps$i = oldProps[i],
      name = _oldProps$i.name,
      value = _oldProps$i.value;
    var newProp = newProps.getNamedItem(name);
    if (!newProp || newProp.value !== value) {
      if (name === 'data-bind') removeNode(property, $target);
      if (!newProp) $target.removeAttribute(name);
    } else {
      newProps.removeNamedItem(name);
    }
  }
  for (var _i = 0; _i < newProps.length; _i++) {
    var _newProps$_i = newProps[_i],
      _name = _newProps$_i.name,
      _value = _newProps$_i.value;
    if (_name === 'selected') $target.parentNode.value = $target.value;
    $target.setAttribute(_name, _value);
  }
  if ($target.type === 'checkbox') {
    $target.checked = $target.hasAttribute('checked');
  }
}
function removeNode(property, $node) {
  var name = $node.getAttribute('data-bind');
  if (!name || $node.tagName === 'SCRIPT') return;
  var nodes = property.pc.p_[name.split('.')[0]].n_;
  var node = nodes.find(function (node) {
    return node.$ === $node;
  });
  nodes.splice(nodes.indexOf(node), 1);
}
function removeNodes(property, $node) {
  if ($node.nodeType === 3) return;
  var $childrens = $node.querySelectorAll('[data-bind]');
  for (var i = 0, $child; $child = $childrens[i]; i++) {
    removeNode(property, $child);
  }
  removeNode(property, $node);
}
function updateElement(property, $parent, $newNode, $oldNode, index) {
  index = index || 0;
  if (!$oldNode) {
    $parent.appendChild($newNode);
  } else if (!$newNode) {
    $parent.removeChild($oldNode);
    removeNodes(property, $oldNode);
  } else if ($newNode.nodeType !== $oldNode.nodeType || $newNode.nodeType === 3 && $newNode.nodeValue !== $oldNode.nodeValue || $newNode.tagName !== $oldNode.tagName) {
    $parent.replaceChild($newNode, $oldNode);
    removeNodes(property, $oldNode);
  } else if ($newNode.nodeType !== 3) {
    updateProps(property, $parent.childNodes[index], $newNode.attributes, $oldNode.attributes);
    updateNodes(property, $oldNode, $newNode);
  }
}
function updateNodes(property, $parent, $path) {
  var oldNodes = Array.from($parent.childNodes);
  var newNodes = Array.from($path.childNodes);
  for (var i = 0; i < newNodes.length || i < oldNodes.length; i++) {
    updateElement(property, $parent, newNodes[i], oldNodes[i], i);
  }
}
;// CONCATENATED MODULE: ./src/view/Template.js



/**
 *
 * @var {template.p} property Propiedad que contiene la plantilla
 * @var {template.$} $node Elemento HTML que sera renderizado por la plantilla
 * @var {template.t} template Plantilla a renderizar
 * @var {template.ip} isParing Valida si la platilla de debe emparejar
 * @var {template.b} base Plantilla base?
 */
var cache = {};
function Template_create(property, $node, $template) {
  return {
    p: property,
    $: $node,
    ip: $template.hasAttribute('data-pairing'),
    t: $template.innerHTML.replace(/\s+/g, ' ').replace(/<\s/g, '<').replace(/\s?\/?\s?>/g, '>'),
    b: $node.innerHTML.replace($template.outerHTML, '').replace(/\s+/g, ' ').replace(/<\s/g, '<').replace(/\s?\/?\s?>/g, '>')
  };
}
function getValue(template) {
  var keys = [];
  var value = [];
  var regex = /\$\{data(?:\.)?([\w\.]*)\}/g;
  var matches;
  while ((matches = regex.exec(template.t)) !== null) {
    keys.push(matches[1]);
  }
  if (!template.ip || !keys.length) return value;
  regex = new RegExp(template.t.trim().replace(/[.*+?^${}()|[\]\\]/g, '\\$&').replace(/\\\$\\\{data(\\\.)?(\w|(\\\.))*\\\}/g, '(.*?)').replace(/\\\$\\\{[^\}]*\}/g, '.*?').replace(/ /g, '\\s*').replace('&', '[?&]amp;'), 'g');
  var _loop = function _loop() {
    var obj = {};
    keys.forEach(function (key, i) {
      setPropertyValue(obj, key ? key.split('.') : key, matches[i + 1]);
    });
    value.push(obj.v);
  };
  while ((matches = regex.exec(template.b)) !== null) {
    _loop();
  }
  return value;
}
function render(template, param) {
  var $node = template.$;
  var property = template.p;
  template = template.t;
  if (!cache[template]) {
    cache[template] = Function('data,index', 'return `' + template + '`');
  }
  updateNodes(property, $node, createFragment(Array.isArray(param) ? param.map(cache[template]).join('') : cache[template](param)));
  $node.dispatchEvent(new Event('mutate'));
  watch(property.c, property.pc, $node);
}
function createFragment(str) {
  var range = document.createRange();
  range.selectNodeContents(document.createElement('template'));
  return range.createContextualFragment(str);
}
;// CONCATENATED MODULE: ./src/observable/Node.js



/**
 *
 * @var {node.ct} complexType Define cuando una propiedad es un array
 * @var {node.$} $node Elemento HTML que es encapsulado por el nodo
 * @var {node.pn_} propertyNames Nombres que componen el nombre del nodo?
 * @var {property.v} value Valor de la propiedad
 * @var {property.n_} nodes Elementos del dom que se controlan mediante la propiedad
 * @var {property.a_} attributes Atributos que controla la propiedad
 */
function isInput(_ref) {
  var nodeName = _ref.nodeName;
  return nodeName === 'INPUT' || nodeName === 'TEXTAREA' || nodeName === 'SELECT';
}
function setValue($node, value, attr) {
  var type = $node.type;
  if (type === 'select-multiple') {
    var _loop = function _loop(option) {
      option.selected = value.find(function (v) {
        return v === option.value;
      });
    };
    for (var i = 0, option; option = $node.options[i]; i++) {
      _loop(option);
    }
    return;
  }
  if (type === 'checkbox' || type === 'radio') {
    attr = 'checked';
    if (type === 'radio') {
      value = $node.value === value;
    }
  } else if (type === 'file') {
    attr = 'files';
  }
  if (value instanceof Date && !isNaN(value)) {
    value = new Date(value.getTime() - value.getTimezoneOffset() * 60000).toJSON().slice(0, type === 'date' ? 10 : 16);
  }
  if ($node[attr] !== value) {
    $node[attr] = value;
    $node.dispatchEvent(new Event('mutate'));
  }
}
function evalValue(_ref2) {
  var type = _ref2.type,
    checked = _ref2.checked,
    value = _ref2.value,
    files = _ref2.files,
    selectedOptions = _ref2.selectedOptions;
  if (type === 'select-multiple') return Array.from(selectedOptions).map(function (_ref3) {
    var value = _ref3.value;
    return value;
  });
  if (type === 'radio') return checked ? value : null;
  if (type === 'file' && files) return files;
  if (type === 'checkbox') return checked;
  return value || null;
}
function changeContent(property, prop, value) {
  var state = clone(property.v);
  setPropertyValue(property, prop, value);
  value = property.v;
  property.n_.forEach(function (node) {
    Node_execute(node, state, value);
  });
  property.a_.forEach(function (attr) {
    execute(property, attr, value);
  });
}
function getObjectValue(obj, props) {
  for (var i = 0, prop; prop = props[i]; i++) {
    if (!obj[prop]) return '';
    obj = obj[prop];
  }
  return obj;
}
function Node_create(property, $node, prop) {
  var value = property.v;
  var complexType = null;
  if (value instanceof Object) {
    value = getObjectValue(value, prop);
  }
  if (isInput($node)) {
    var inputValue = evalValue($node);
    $node.type.indexOf('date') && $node.addEventListener('keyup', function (e) {
      changeContent(property, prop, evalValue(e.target));
    });
    $node.addEventListener('change', function (e) {
      changeContent(property, prop, evalValue(e.target));
    });
    if (inputValue === null) {
      setValue($node, value, 'value');
    } else {
      value = inputValue;
    }
  } else if ($node.tagName === 'SCRIPT' && $node.type === 'text/template') {
    complexType = Template_create(property, $node.parentNode, $node);
    value = getValue(complexType);
  } else if ($node.innerHTML) {
    var $template = $node.querySelector('script[type="text/template"]');
    value = $node.innerHTML;
    if ($template) {
      complexType = Template_create(property, $node, $template);
      value = getValue(complexType);
    }
  } else {
    setValue($node, value, 'innerHTML');
  }
  setPropertyValue(property, prop, value);
  return {
    pn_: prop,
    $: $node,
    ct: complexType
  };
}
function Node_execute(node, state, value) {
  var $node = node.$;
  var complexType = node.ct;
  node.pn_.forEach(function (propName) {
    value = value[propName];
    state = state[propName];
  });
  if (value !== state) {
    complexType && value ? render(complexType, value) : setValue($node, value, isInput($node) ? 'value' : 'innerHTML');
  }
}
;// CONCATENATED MODULE: ./src/observable/Property.js




/**
 *
 * @var {property.c} component Referencia al componente que pertence la propiedad
 * @var {property.v} value Valor de la propiedad
 * @var {property.n_} nodes Elementos del dom que se controlan mediante la propiedad
 * @var {property.a_} attributes Atributos que controla la propiedad
 * @var {property.o_} overlapings Componentes sobre los que se generan solapamientos
 * @var {property.o} observable Valor al que se le realizan las modificaciones
 * @var {property.p} proxy Proxy de value cuando se devuelve un objeto
 * @var {component.$} $node Elemento base del componente
 * @var {component.m} module Módulo que genero el componente
 * @var {component.p_} properties Propiedades del componente
 * @var {component.e_} events Eventos que debe escuchar el componente
 * @var {component.pc} privateComponent Propiedades privadas del componente
 */
var getPropertyHandler = function getPropertyHandler(property, root) {
  return {
    set: function set(target, prop, value) {
      root = root || target;
      var state = clone(root);
      if (value instanceof Promise) {
        return value.then(function (data) {
          if (Reflect.set(target, prop, data)) return _set(property, root, state);
        });
      }
      if (Reflect.set(target, prop, value)) {
        return _set(property, root, state);
      }
    },
    get: function get(target, prop, receiver) {
      var value = Reflect.get(target, prop, receiver);
      if (value) {
        var _constructor = value.constructor;
        root = root || target;
        if (_constructor === Function) {
          return new Proxy(value.bind(target), {
            apply: function apply(target, thisArg, argumentsList) {
              var state = clone(root);
              var res = Reflect.apply(target, thisArg, argumentsList);
              _set(property, root, state);
              return res;
            }
          });
        }
        if (_constructor === Object || _constructor === Array) {
          return new Proxy(value, getPropertyHandler(property, root));
        }
      }
      return value;
    }
  };
};
function Property_changeContent(property, value, state) {
  property.v = value;
  property.n_.forEach(function (node) {
    Node_execute(node, state, value);
  });
  property.a_.forEach(function (attr) {
    execute(property, attr, value);
  });
  return true;
}
function addOverloap(component, property, name) {
  component = get(component);
  var prop = component.p_[name];
  var events = Object.assign({}, property.pc.e_);
  prop.o_.push(property);
  property.o_.push(prop);
  for (var _name in events) {
    if (events[_name] instanceof Function) {
      delete events[_name];
    }
  }
  Object.assign(component.e_, events);
}
function findComponent(property, $node, name) {
  var components = property.pc.m.c_;
  if ($node.parentNode) {
    var parentNode = $node.parentNode;
    if (parentNode.dataset && parentNode.dataset.component) {
      var uuid = parentNode.dataset.component;
      if (components[uuid][name]) {
        addOverloap(components[uuid], property, name);
      }
    }
    findComponent(property, $node.parentNode, name);
  }
}
function Property_create(component, name) {
  var _component$name;
  var privyComponent = get(component);
  var property = {
    c: component,
    pc: privyComponent,
    v: (_component$name = component[name]) !== null && _component$name !== void 0 ? _component$name : '',
    n_: [],
    a_: [],
    o_: []
  };
  findComponent(property, privyComponent.$, name);
  return property;
}
function Property_get(property) {
  var value = property.v;
  if (value instanceof Object) {
    if (property.o !== value) {
      property.p = new Proxy(value, getPropertyHandler(property));
      property.o = value;
    }
    return property.p;
  }
  return value;
}
function _set(property, value, state) {
  property.o_.forEach(function (prop) {
    return prop.v = value;
  });
  return value instanceof Promise ? value.then(function (data) {
    return Property_changeContent(property, data, state);
  }) : Property_changeContent(property, value, state);
}

function addNode(property, $node, prop) {
  if (!property.n_.find(function (node) {
    return node.$ === $node;
  })) {
    property.n_.push(Node_create(property, $node, prop));
  }
}
function addAttribute(property, name, $element, prop, exp) {
  property.a_.push(create(property, name, $element, prop, exp));
}
;// CONCATENATED MODULE: ./src/observable/Component.js
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }




/**
 *
 * @var {component.$} $node Elemento HTML asoociado al componente
 * @var {component.m} module Módulo que genero el componente
 * @var {component.pc} privateComponent Propiedades privadas del componente
 * @var {component.p_} properties Propiedades del componente
 * @var {component.e_} events Eventos que seran ejecutados por el componente
 * @var {property.v} value Valor de la propiedad
 *
 */
function getProperty(component, name) {
  var prop = Property_create(component, name);
  Object.defineProperty(component, name, {
    get: function get() {
      return Property_get(prop);
    },
    set: function set(value) {
      return _set(prop, value, clone(prop.v));
    }
  });
  return prop;
}
function bindData(component, privyComponent, $domElement) {
  var name = $domElement.dataset.bind;
  var properties = privyComponent.p_;
  var propertyObj = name.split('.');
  name = propertyObj.shift();
  if (!properties[name]) {
    properties[name] = getProperty(component, name);
  }
  addNode(properties[name], $domElement, propertyObj);
}
function bindAttributes(component, privyComponent, $domElement) {
  $domElement.dataset.attr.split(';').forEach(function (attribute) {
    var index = attribute.indexOf(':');
    var properties = [];
    var exp = attribute.substr(index + 1).trim();
    exp.replace(/'[^']*'/g, '').match(/(^\w[\w\._]+)(?!\${index})/g).forEach(function (prop) {
      var props = prop.split('.');
      var name = props.shift();
      var privy = privyComponent.p_;
      if (!privy[name]) {
        privy[name] = getProperty(component, name);
      }
      exp = exp !== prop ? exp.replaceAll(prop, 'p.' + prop.replace(/\.([\w_]+)/g, "['$1']")) : null;
      properties.push({
        p_: props,
        v: privy[name]
      });
    });
    properties.forEach(function (prop) {
      addAttribute(prop.v, attribute.substr(0, index).trim(), $domElement, prop.p_, exp);
    });
  });
}
function watch(component, privyComponent, $node) {
  var dataset = $node.dataset;
  var dataBinds = Array.from($node.querySelectorAll('[data-bind]'));
  var dataAttributes = Array.from($node.querySelectorAll('[data-attr]'));
  if (dataset) {
    if (dataset.bind) dataBinds.push($node);
    if (dataset.attr) dataAttributes.push($node);
  }
  dataBinds.forEach(function ($bind) {
    return bindData(component, privyComponent, $bind);
  });
  dataAttributes.forEach(function ($attr) {
    return bindAttributes(component, privyComponent, $attr);
  });
  addListeners($node, privyComponent.e_);
}
function _compose($node, behavioral, module) {
  var props = {
    $: $node,
    m: module,
    p_: {}
  };
  var behavioralIsComponent = behavioral.prototype instanceof Component;
  var component = behavioralIsComponent ? new behavioral() : new Component();
  set(component, props);
  props.e_ = behavioralIsComponent ? component.listen && component.listen() : behavioral(component);
  watch(component, props, $node);
  $node.dispatchEvent(new Event('mount'));
  return component;
}

var Component = /*#__PURE__*/function () {
  function Component() {
    _classCallCheck(this, Component);
  }
  _createClass(Component, [{
    key: "inject",
    value: function inject(provider) {
      return get(this).m.inject(provider);
    }
  }, {
    key: "compose",
    value: function compose($domElement, behavioral) {
      return _compose($domElement, behavioral, get(this).m);
    }
  }, {
    key: "getIndex",
    value: function getIndex(e) {
      var $node = get(this).$;
      var parent = e.target;
      do {
        var key = parent.dataset.key;
        if (key) return key;
        parent = parent.parentNode;
      } while (parent !== $node);
    }
  }]);
  return Component;
}();

;// CONCATENATED MODULE: ./src/Module.js
function Module_typeof(o) { "@babel/helpers - typeof"; return Module_typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, Module_typeof(o); }
function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }
function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function Module_classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function Module_defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, Module_toPropertyKey(descriptor.key), descriptor); } }
function Module_createClass(Constructor, protoProps, staticProps) { if (protoProps) Module_defineProperties(Constructor.prototype, protoProps); if (staticProps) Module_defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function Module_toPropertyKey(t) { var i = Module_toPrimitive(t, "string"); return "symbol" == Module_typeof(i) ? i : String(i); }
function Module_toPrimitive(t, r) { if ("object" != Module_typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != Module_typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }



/**
 *
 * @var {module.c_} components Componentes generados por el módulo
 * @var {module.C} classes Clases provistas para el contenedor de dependencias
 * @var {module.i_} instances Objetos creados por el contenedor de dependencias
 */
var Module = /*#__PURE__*/function () {
  function Module() {
    Module_classCallCheck(this, Module);
    this.c_ = [];
    var properties = {
      C: {},
      i_: {},
      c_: {},
      inject: function inject(provider) {
        var instances = properties.i_;
        var uuid = provider.uuid;
        if (!instances[uuid]) {
          instances[uuid] = new properties.C[uuid](properties.inject);
          instances[uuid].uuid = uuid;
        }
        ;
        return instances[uuid];
      }
    };
    set(this, properties);
    for (var _len = arguments.length, providers = new Array(_len), _key = 0; _key < _len; _key++) {
      providers[_key] = arguments[_key];
    }
    providers.forEach(function (provider) {
      if (!provider.uuid) {
        properties.C[generateUUID(provider)] = provider;
      }
    });
  }
  Module_createClass(Module, [{
    key: "compose",
    value: function compose(selector, behavioral) {
      this.c_.push([selector, behavioral]);
      return this;
    }
  }, {
    key: "bind",
    value: function bind(origin, replace) {
      get(this).C[origin.uuid] = replace;
      return this;
    }
  }, {
    key: "add",
    value: function add(module) {
      var src = get(module);
      var dst = get(this);
      Object.assign(dst.C, src.C);
      Object.assign(dst.i_, src.i_);
      return this;
    }
  }, {
    key: "execute",
    value: function execute() {
      var module = get(this);
      var element;
      while (element = this.c_.shift()) {
        if (/^[a-z]+-/.test(element[0])) {
          var _customElements;
          element[1].m = this;
          if (element[1].t) {
            element.push({
              "extends": element[1].t
            });
          }
          (_customElements = customElements).define.apply(_customElements, _toConsumableArray(element));
        } else {
          var $nodes = document.querySelectorAll(element[0]);
          for (var i = 0, $node; $node = $nodes[i]; i++) {
            var component = _compose($node, element[1], module);
            module.c_[component.uuid] = component;
            $node.dataset.component = component.uuid;
          }
        }
      }
    }
  }]);
  return Module;
}();

;// CONCATENATED MODULE: ./src/customElement.js
function customElement_typeof(o) { "@babel/helpers - typeof"; return customElement_typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, customElement_typeof(o); }
function customElement_defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, customElement_toPropertyKey(descriptor.key), descriptor); } }
function customElement_createClass(Constructor, protoProps, staticProps) { if (protoProps) customElement_defineProperties(Constructor.prototype, protoProps); if (staticProps) customElement_defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function customElement_toPropertyKey(t) { var i = customElement_toPrimitive(t, "string"); return "symbol" == customElement_typeof(i) ? i : String(i); }
function customElement_toPrimitive(t, r) { if ("object" != customElement_typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != customElement_typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function customElement_classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _callSuper(t, o, e) { return o = _getPrototypeOf(o), _possibleConstructorReturn(t, _isNativeReflectConstruct() ? Reflect.construct(o, e || [], _getPrototypeOf(t).constructor) : o.apply(t, e)); }
function _possibleConstructorReturn(self, call) { if (call && (customElement_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _isNativeReflectConstruct() { try { var t = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); } catch (t) {} return (_isNativeReflectConstruct = function _isNativeReflectConstruct() { return !!t; })(); }
function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }
function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }



/**
 *
 * @var {E} Element Elemento HTML del que hereda el componente
 * @var {t} type Tipo de elemento a heredar (p, ul, button)
 * @var {C} Component Clase cruzada entre el elemento y Component para heredar
 * @var {m} module Referencia al módulo que esta componiendo la clase
 * @var {i} initialized Flag que indica si el web component ha sido inicializado
 */
var TYPES = {
  p: HTMLParagraphElement,
  ul: HTMLUListElement,
  button: HTMLButtonElement,
  select: HTMLSelectElement,
  image: HTMLImageElement
};
function customElement(options) {
  var type = options.type;
  var fetch = TYPES[type] ? {
    t: type,
    E: TYPES[type]
  } : {
    E: HTMLElement
  };
  var component = fetch.C;
  if (!component) {
    component = /*#__PURE__*/function (_fetch$E) {
      _inherits(component, _fetch$E);
      function component() {
        var _this2;
        customElement_classCallCheck(this, component);
        _this2 = _callSuper(this, component);
        _this2.attachShadow({
          mode: 'open'
        });
        return _this2;
      }
      return customElement_createClass(component);
    }(fetch.E);
    var componentMethods = ["inject", "getIndex", "compose"];
    for (var i = 0, method; method = componentMethods[i]; i++) {
      component.prototype[method] = Component.prototype[method];
    }
    fetch.C = component;
  }
  return function decorator(Class) {
    if (type) Class.t = type;
    var prototype = Class;
    while (prototype.__proto__ !== Component) {
      prototype = prototype.__proto__;
    }
    Object.setPrototypeOf(prototype, component);
    Object.setPrototypeOf(prototype.prototype, component.prototype);
    Object.defineProperty(Class, 'observedAttributes', {
      get: function get() {
        var str = this.toString();
        var _this = /(\w+)\s*=.+this[^\.]/.exec(str);
        var properties = str.match(new RegExp('(?<=' + (_this ? _this[1] : 'this') + '\\.)[^_\\$](\\w+(?=\\s*=))', 'g')) || [];
        return properties.map(function (property) {
          return property.replace(/([a-z])([A-Z])/g, '$1-$2').toLowerCase();
        });
      }
    });
    var methods = {
      connectedCallback: function connectedCallback(_this) {
        if (!get(_this).i) _this.onInit();
      },
      attributeChangedCallback: function attributeChangedCallback(_this, name, oldValue, newValue) {
        if (!get(_this).i) _this.onInit();
        name = name.replace(/-./g, function (x) {
          return x[1].toUpperCase();
        });
        if (typeof _this[name] === 'boolean') {
          newValue = true;
        } else if (_this[name] instanceof Object) {
          newValue = JSON.parse(newValue);
        }
        _this[name] = newValue;
      },
      onInit: function onInit(_this) {
        var props = {
          $: _this.shadowRoot,
          m: get(Class.m),
          p_: {},
          e_: _this.listen ? _this.listen() : {},
          i: true
        };
        props.$.appendChild(createFragment('<style>' + (options.styles || '') + '</style>' + (options.template || '')));
        set(_this, props);
        watch(_this, props, props.$);
      }
    };
    var _loop = function _loop(_method) {
      var userMethod = Class.prototype[_method];
      Class.prototype[_method] = function () {
        for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }
        methods[_method].apply(methods, [this].concat(args));
        userMethod && userMethod.bind(this).apply(void 0, args);
      };
    };
    for (var _method in methods) {
      _loop(_method);
    }
    return Class;
  };
}
;// CONCATENATED MODULE: ./src/scalar.js




/******/ 	return __webpack_exports__;
/******/ })()
;
});